--- title: "Design" slug: "server-api-kb-design" updated: 2022-06-16T07:58:39Z published: 2022-06-16T07:58:39Z canonical: "developer.comm100.com/server-api-kb-design" --- > ## Documentation Index > Fetch the complete documentation index at: https://developer.comm100.com/llms.txt > Use this file to discover all available pages before exploring further. # Design ## Design You need the Manage design permission to manage design. - `Designs` - Designs Manage - `GET kb/designs` - [Get the list of Designs](/docs/server-api-kb-design#get-the-list-of-designs) - `GET kb/designs/{id}` - [Get a single Design](/docs/server-api-kb-design#get-a-single-design) - `PUT kb/designs/{id}` - [Update the Design](/docs/server-api-kb-design#update-the-design) ### Design JSON Format Design is represented as simple flat JSON objects with the following keys: | Name | Type | Description | | --- | --- | --- | | `id` | guid | Id of the design. | | `pageType` | string | Allowed values are "cssFile", "categoryPage", "articlePage", "searchResultPage", "pageNotFound". | | `kbId` | guid | Id of the knowledage base. | | `body` | string | Content of the design. You can pass both plaintext and base64 encode text. If the request containing plaintext is blocked by comm100 WAF, use base64 format. When using base64, add "data:text/plain;base64," before the content. | | `modifiedTime` | timestamp | Time when the design was last modified. | | `modifiedById` | guid | Id of the agent who modified the design. | ### Get the list of Designs `GET kb/designs` - #### Parameters: | Name | Type | in | Required | Description | | --- | --- | --- | --- | --- | | `kbId` | guid | query | no | Id of the knowledage base. | - #### Response: An array of [Design](/docs/server-api-kb-design#design-json-format) - #### Example Sample Request: ``` curl https://api11.comm100.io/v4/kb/designs \ -X 'GET' \ -H 'Authorization: Bearer {access_token}' \ ``` Response: HTTP/1.1 200 OK ``` [ { "id": "8aa9aac0-1f99-eb11-a80f-00155d081c1b", "pageType": "articlePage", "kbId": "b2754e68-b380-4a61-9c5b-a9570f1a4fcc", "body": "\n?\n?\n? \n? \n? \n? \n? \n? \n? \n? \n?\n?\n?
\n?
\n? \n?
\n? \n? \n?
\n?
\n?
\n?
\n?
\n?
\n? {{breadcrumbs}}\n?
\n?
\n?
\n? {{title}}\n?
\n?
\n? {{body}}\n?
\n? {% if ifAllowFeedback %}\n?
\n?
\n? Helpful?\n? \n? \n?\n?
{{feedBackCount | round: 2}}% of people found this helpful
\n?\n?
\n? {% endif %}\n?
\n? {% if ifShowPoweredBy %}\n?
\n? \n? \n? \n?
\n? {% endif %}\n?
\n?
\n? \n?\n?", "modifiedTime": "2021-04-09T10:38:47.25Z", "modifiedById": "21b5d834-b98b-48ba-ae45-0d1316cb382f" } ] ``` ### Get a single Design `GET kb/designs/{id}` - #### Parameters: No Parameters - #### Response: [Design](/docs/server-api-kb-design#design-json-format) - #### Example Sample Request: ``` curl https://api11.comm100.io/v4/kb/designs/8aa9aac0-1f99-eb11-a80f-00155d081c1b \ -X 'GET' \ -H 'Authorization: Bearer {access_token}' \ ``` Response: HTTP/1.1 200 OK ``` { "id": "8aa9aac0-1f99-eb11-a80f-00155d081c1b", "pageType": "articlePage", "kbId": "b2754e68-b380-4a61-9c5b-a9570f1a4fcc", "body": "\n?\n?\n? \n? \n? \n? \n? \n? \n? \n? \n?\n?\n?
\n?
\n? \n?
\n? \n? \n?
\n?
\n?
\n?
\n?
\n?
\n? {{breadcrumbs}}\n?
\n?
\n?
\n? {{title}}\n?
\n?
\n? {{body}}\n?
\n? {% if ifAllowFeedback %}\n?
\n?
\n? Helpful?\n? \n? \n?\n?
{{feedBackCount | round: 2}}% of people found this helpful
\n?\n?
\n? {% endif %}\n?
\n? {% if ifShowPoweredBy %}\n?
\n? \n? \n? \n?
\n? {% endif %}\n?
\n?
\n? \n?\n?", "modifiedTime": "2021-04-09T10:38:47.25Z", "modifiedById": "21b5d834-b98b-48ba-ae45-0d1316cb382f" } ``` ### Update the Design `PUT kb/designs/{id}` - #### Parameters: | Name | Type | in | Required | Description | | --- | --- | --- | --- | --- | | `pageType` | string | body | no | Allowed values are "cssFile", "categoryPage", "articlePage", "searchResultPage", "pageNotFound". | | `kbId` | guid | body | yes | Id of the knowledage base. | | `body` | string | body | no | Content of the design. You can pass both plaintext and base64 encode text. If the request containing plaintext is blocked by comm100 WAF, use base64 format. When using base64, add "data:text/plain;base64," before the content. | | `modifiedById` | guid | body | no | Id of the agent who modified the design. | - #### Response: [Design](/docs/server-api-kb-design#design-json-format) - #### Example Sample Request: ``` curl https://api11.comm100.io/v4/kb/designs/8aa9aac0-1f99-eb11-a80f-00155d081c1b \ -X 'PUT' \ -H 'Authorization: Bearer {access_token}' \ -H 'Content-Type: application/json' \ -D '{"pageType":"articlePage","kbId":"b2754e68-b380-4a61-9c5b-a9570f1a4fcc","body":"\n?\n?\n? \n? \n? \n? \n? \n? \n? \n? \n?\n?\n?
\n?
\n? \n?
\n? \n? \n?
\n?
\n?
\n?
\n?
\n?
\n? {{breadcrumbs}}\n?
\n?
\n?
\n? {{title}}\n?
\n?
\n? {{body}}\n?
\n? {% if ifAllowFeedback %}\n?
\n?
\n? Helpful?\n? \n? \n?\n?
{{feedBackCount | round: 2}}% of people found this helpful
\n?\n?
\n? {% endif %}\n?
\n? {% if ifShowPoweredBy %}\n?
\n? \n? \n? \n?
\n? {% endif %}\n?
\n?
\n? \n?\n?","modifiedById":"21b5d834-b98b-48ba-ae45-0d1316cb382f"}' ``` Response: HTTP/1.1 200 OK ``` { "id": "8aa9aac0-1f99-eb11-a80f-00155d081c1b", "pageType": "articlePage", "kbId": "b2754e68-b380-4a61-9c5b-a9570f1a4fcc", "body": "\n?\n?\n? \n? \n? \n? \n? \n? \n? \n? \n?\n?\n?
\n?
\n? \n?
\n? \n? \n?
\n?
\n?
\n?
\n?
\n?
\n? {{breadcrumbs}}\n?
\n?
\n?
\n? {{title}}\n?
\n?
\n? {{body}}\n?
\n? {% if ifAllowFeedback %}\n?
\n?
\n? Helpful?\n? \n? \n?\n?
{{feedBackCount | round: 2}}% of people found this helpful
\n?\n?
\n? {% endif %}\n?
\n? {% if ifShowPoweredBy %}\n?
\n? \n? \n? \n?
\n? {% endif %}\n?
\n?
\n? \n?\n?", "modifiedTime": "2021-04-09T10:38:47.25Z", "modifiedById": "21b5d834-b98b-48ba-ae45-0d1316cb382f" } ```